'-------------------------------------------------------------------------------------------
' SELECT CASE Bug v5.05.06B15 and v5.05.06RC6 and EXP VERSION 2020-10-27_194858_CMM2V1.5
'-------------------------------------------------------------------------------------------

'Recommended Program Practice
OPTION EXPLICIT          ' Variables must be typed
OPTION DEFAULT NONE      ' Variables must be declared

'Global Variables and Constants
CONST WIDTH%    = 20       ' Number of Maze Columns (minimum 5) will be doubled+1 size
CONST LENTH%    = 20       ' Number of Maze Rows (minimum 5) will be doubled+1 size

'Declare Global Arrays
DIM m$(2*LENTH%+1) length 2*WIDTH+1   ' Maze String Array, each string 2*WIDTH+1 chars long

'-------------------------------------------------------------------------------------------
' Test Program

 DIM wt$                   ' SELECT CASE workaround variable
 DIM mR%                   ' Counter for printing a row of the maze
 DIM mC%                   ' Counter for individual map character from string

 FOR mR% = 1 TO (2*LENTH%+1)
    m$(mR%) = "#123456789X123456789@123456789X123456789#"
 NEXT mR%

 'Print Maze Description
 CLS
 COLOUR RGB(WHITE)
 PRINT
 PRINT "Width:" 2*WIDTH%+1 "  Length:" 2*LENTH%+1 
 PRINT

 'Display the m$() array contents
 FOR mR% = 1 to (LENTH% + LENTH% +1)


'
'
' HERE IS THE BUG, AND THE VARIATIONS I TRIED
'
' This causes the dreaded Error System Fault v5.05.06B15 nd v5.05.06RC6 and 2020-10-27_194858_CMM2V1
'
'
' Reply from Peter ... known MMBasic problem
' The workaround is to copy the array value into a temporary variable and test that
'
  FOR mC% = 1 to 2*WIDTH%+1
    wt$ = MID$(m$(mR%), mC%, 1)
    SELECT CASE wt$
       CASE "@"
          COLOUR RGB(RED)
       CASE "X"
          COLOUR RGB(GREEN)
       CASE "#"
          COLOUR RGB(BROWN)
       CASE ELSE
          COLOUR RGB(WHITE)
    END SELECT
    PRINT wt$;
'
' Just printing without the COLOUR change works fine !!! No idea why?
'    PRINT m$(mR%)
'
  NEXT mC%
  PRINT              ' Carriage Return
 NEXT mR%
 COLOUR RGB(WHITE)

 ' Exit Program Gracefully
 END

'-------------------------------------------------------------------------------------------


